/*
 * UUCODE - A uudecode/uuencode desk accessory version 1.1
 * by Matt Kimmel
 *
 * Based on ASTUUD.C and ASTUUE.C from the Bitnet Kermit Server
 *
 * Send comments to Matt Kimmel:
 * KIMMEL@UMAECS.BITNET               \
 * KIMMEL@ECS.UMASS.EDU               | Preferred
 * KIMMEL%UMAECS.BITNET@WISCVM.ARPA   /
 *
 * or
 *
 * Matt@UMass.BITNET
 * Matt%UMass.BITNET@wiscvm.ARPA
 *
 * Bugs in version 1.0:
 *
 * In UUENCODE, the file that is encoded has a character appended to it.
 * This is WEIRD.  The file is opened in "br" mode, and is never written
 * to.  Maybe this is a bug in the Megamax file i/o libraries?  GEM?
 * TOS?  Who knows?  Let me know if you find a fix for it.
 *
 * Version 1.1 notes:
 * Modified file selectors so they look on the default drive instead of
 * drive A.  That tripped up some hard disk users.
 */

#include <stdio.h>
#include <gemdefs.h>
#include <osbind.h>
#include <string.h>

#define ENC(c) (((c) & 077) + ' ')
#define DEC(c) (((c) - ' ') & 077)

main()
{
  int apid, menuid;
  int msg[8];

  apid = appl_init();
  menuid = menu_register(apid,"  UUCODE");
  for (;;) {
    evnt_mesag(msg);
    if (msg[0] == AC_OPEN) acc();
    }
}
  
acc()
{
  int which;

  which = form_alert(3,"[2][UUCODE|Which operation?][Encode|Decode|Cancel]");
  switch(which) {
    case 1 : graf_mouse(2,&which);
             uuencode();
             graf_mouse(0,&which);
             break;
    case 2 : graf_mouse(2,&which);
             uudecode();
             graf_mouse(0,&which);
             break;
    }
}

int getfn(path,name)
char *path, *name;
{
  char p[81], f[16], *e;
  int j;

  p[0] = (Dgetdrv() + 'A');
  p[1] = '\0';
  strcat(p,":\\*.*");
  strcpy(f,name);
  j = 0;
  fsel_input(p,f,&j);
  if (j == 0) return (0);
  e = index(p,'*');
  *e = '\0';
  strcpy(path,p);
  strcat(path,f);
  strcpy(name,f);
  return (j);
}

int uuencode()
{
  char path[128], name[16], oname[16];
  int ok;
  char outpath[128], *e;
  FILE *in, *out;

  name[0] = '\0';
  ok = getfn(path,name);
  if (ok == 0) return (0);
  if ((in = fopen(path,"br")) == NULL) {
    form_alert(1,"[3][File not found.][Cancel]");
    return (0);
    }
  strcpy(oname,name);
  e = index(name,'.');
  *e = '\0';
  strcat(name,".UUE");
  ok = getfn(outpath,name);
  if (ok == 0) return (0);
  if ((out = fopen(outpath,"w")) == NULL) {
    form_alert(1,"[3][Can't open .UUE file][Cancel]");
    return (0);
    }
  graf_mouse(2,&ok);
  fprintf(out,"begin 644 %s\n",oname);
  encode(in,out);
  fprintf(out,"end\n");
  fclose(in);
  fclose(out);
}

encode(in,out)
FILE *in, *out;
{
  char buf[80];
  int i, n;

  for(;;) {
    n = fr(in, buf, 45);
    putc(ENC(n), out);
    for (i = 0; i < n; i += 3) outenc(&buf[i], out);
    fputs("u\n",out);
    if (n <= 0) break;
    }
}

outenc(p,f)
char *p;
FILE *f;
{
  int c1, c2, c3, c4;

  c1 = *p >> 2;
  c2 = (*p << 4) & 060 | (p[1] >> 4) & 017;
  c3 = (p[1] << 2) & 074 | (p[2] >> 6) & 03;
  c4 = p[2] & 077;
  putc(ENC(c1), f);
  putc(ENC(c2), f);
  putc(ENC(c3), f);
  putc(ENC(c4), f);
}

int fr(fd, buf, cnt)
FILE *fd;
char *buf;
int cnt;
{
  int c, i;

  for (i = 0; i < cnt; i++) {
    c = getc(fd);
    if (c == EOF) return (i);
    buf[i] = c;
    }
  return (cnt);
}

int uudecode()
{
  char inpath[81], outpath[81], name[16];
  char line[256], junk[256];
  FILE *in, *out;
  int ok;

  name[0] = '\0';
  ok = getfn(inpath,name);
  if (ok == 0) return (0);
  if ((in = fopen(inpath,"r")) == NULL) {
    form_alert(1,"[3][Can't find .UUE file][Cancel]");
    return (0);
    }
  do {
    if ((fgets(line,255,in) == NULL)) return (0);
    } while (strncmp(line,"begin ",6));
  sscanf(line,"%s %s %s",junk,junk,name);
  ok = getfn(outpath,name);
  if (ok == 0) return(0);
  if ((out = fopen(outpath,"bw")) == NULL) {
    form_alert(1,"[3][Can't open output|file][Cancel]");
    return (0);
    }
  graf_mouse(2,&ok);
  decode(in,out);
  if ((fgets(line,256,in) == NULL) || strcmp(line,"end\n")) 
    form_alert(1,"[1][No end line.][Continue]");
  fclose(in);
  fclose(out);
}

decode(in, out)
FILE *in, *out;
{
  char buf[80];
  char *bp, *e;
  int n, j;

  for (;;) {
    if (fgets(buf, sizeof buf, in) == NULL) {
      form_alert(1,"[3][Short file!][Continue]");
      return (0);
      }
    n = DEC(buf[0]);
    if (n <= 0) break;
    if (strlen(buf) < n) {
      e = index(buf,'\n');
      *e = '\0';
      for (j=0;j++ <= ((n - strlen(buf)) - 1); strcat(buf," "));
      }
    bp = &buf[1];
    while (n > 0) {
      outdec(bp,out,n);
      bp += 4;
      n -= 3;
      }
    }
}

outdec(p, f, n)
char *p;
FILE *f;
int n;
{
  int c1, c2, c3;

  c1 = DEC(*p) << 2 | DEC(p[1]) >> 4;
  c2 = DEC(p[1]) << 4 | DEC(p[2]) >> 2;
  c3 = DEC(p[2]) << 6 | DEC(p[3]);
  if (n >= 1) putc(c1, f);
  if (n >= 2) putc(c2, f);
  if (n >= 3) putc(c3, f);
}